
import pygame
import sys
from pygame.locals import *
import os
import random



w = 750
h = 500


fon_dir = os.path.join(os.path.dirname(__file__), "font")
print(fon_dir)




class MainWindow():

    def __init__(self):
        pygame.init()
        self.time_left=120
        self.time_left_event=pygame.USEREVENT+4
        self.background1=pygame.image.load("img_4.png")
        self.background1=pygame.transform.scale(self.background1,(500,500))

        pygame.mixer.init()
        self.a=5
        self.screen = pygame.display.set_mode((w, h))
        pygame.display.set_caption("redpacket game")
        self.player1 = Player1()
        self.player2=Player2()
        self.rocks = pygame.sprite.Group()
        self.bgimg=pygame.image.load("img_3.png")
        self.bgimg=pygame.transform.scale(self.bgimg,(750,500))
        self.freq = 0
        self.socre1 = 0
        self.socre2=0




    ### 绘制文本
    def draw_text(self, surf, text, size, x, y,R,G,B):
        font = pygame.font.Font('Snell Roundhand Bold Script.ttf', size)
        text_surface = font.render(text, True, (R,G,B))
        text_rect = text_surface.get_rect()
        text_rect.midtop = (x, y)
        surf.blit(text_surface, text_rect)

    def gostart(self):

        self.screen.fill((255,255,255))
        self.screen.blit(self.background1, (125, 0))
        self.draw_text(self.screen, "Redpacket game", 60, w / 2, 100,0,0,0)
        self.draw_text(self.screen, "press space to start", 20, w / 2, 300,0,0,0)
        pygame.display.update()
        while True:
            for event in pygame.event.get():
                if event.type == QUIT:
                    pygame.quit()
                    sys.exit()
                elif event.type == KEYDOWN:
                    if event.key == K_SPACE:
                        return

    def show(self):
        # self.screen.fill((255,255,255))
        pygame.time.set_timer(self.time_left_event,1000)
        pygame.mixer.music.stop()
        pygame.mixer.music.load("song.mp3")
        pygame.mixer.music.set_volume(0.1)
        pygame.mixer.music.play(-1)


        # self.draw_text(self.screen, "redpacket game", 60, w / 2, 100)
        pygame.display.update()
        while True:
            self.cheak_quit()
            # self.show_rock()
            self.a=self.a
            self.screen.blit(self.bgimg, (0, 0))
            self.player1.draw_plane(self.screen)
            self.player2.draw_plane(self.screen)
            self.cheak_pressed()
            self.player1.allSprites.draw(self.screen)
            self.player2.allSprites.draw(self.screen)
            self.rocks.update()
            self.rocks.draw(self.screen)
            self.show_rock()
            self.draw_text(self.screen, "player red score: " + str(self.socre1), 30, 150, 3,255, 17, 17)
            self.draw_text(self.screen, "player blue score: " + str(self.socre2), 30, 600, 3,0,255,255)
            self.draw_text(self.screen, "time left: " + str(self.time_left), 30, w//2, 400, 255, 255, 255)
            # self.draw_text(self.screen, "time left: " + str1(self.time_left), 30,400,0, 255, 255, 255)
            self.chachredpacket()
            pygame.display.update()
            if self.time_left<=0:
                self.gameover(self.screen)
                break
    def gameover(self,scr):
        self.image = pygame.image.load("img_5.png").convert_alpha()
        self.image = pygame.transform.scale(self.image, (400,400))
        self.image1=pygame.image.load("img_1.png")
        self.image1 = pygame.transform.scale(self.image1, (50, 100))
        self.image2=pygame.image.load("img_2.png")
        self.image2 = pygame.transform.scale(self.image2, (50, 100))
        self.screen.blit(self.bgimg, (0, 0))
        pygame.mixer.music.stop()
        scr.blit(self.image, (175, 100))
        self.draw_text(self.screen, "player red score: " + str(self.socre1), 30, 150, 450, 255, 17, 17)
        self.draw_text(self.screen, "player blue score: " + str(self.socre2), 30, 600, 450, 0, 255, 255)
        if self.socre1>self.socre2:
            scr.blit(self.image1,(350,200))
        elif self.socre2>self.socre1:
            scr.blit(self.image2, (350, 200))
        else:
            scr.blit(self.image1,(325,200))
            scr.blit(self.image2,(375,200))



        pygame.display.update()
        while True:
            for event in pygame.event.get():
                if event.type == QUIT:
                    pygame.quit()
                    sys.exit()



    def cheak_quit(self):
        for event in pygame.event.get():
            if event.type == QUIT:
                pygame.quit()
                sys.exit()
            elif event.type == self.time_left_event:
                self.time_left-=1
                print(self.time_left)

    def cheak_pressed(self):
        keys = pygame.key.get_pressed()
        if keys[K_LEFT]:
            self.player2.moveleft()
        if keys[K_RIGHT]:
            self.player2.moveright()
        if keys[K_UP]:
            self.player2.moveup()
        if keys[K_DOWN]:
            self.player2.movedown()
        if keys[K_a]:
            self.player1.moveleft()
        if keys[K_s]:
            self.player1.movedown()
        if keys[K_d]:
            self.player1.moveright()
        if keys[K_w]:
            self.player1.moveup()

    def show_rock(self):
        if self.freq % 5 == 0:
            for i in range(2):
                rock = Rocks(self.a)
                self.rocks.add(rock)
                self.freq = 0
        self.freq = self.freq + 1

    def chachredpacket(self):
        if pygame.sprite.spritecollide(self.player1,self.rocks,True):
            self.socre1+=1
            if self.socre1 % 20 == 0 and self.a != 35:
                self.a = self.a + 2
            # print(self.a)

        if pygame.sprite.spritecollide(self.player2,self.rocks,True):
            self.socre2+=1
            if self.socre2 % 20 == 0 and self.a != 35:
                self.a = self.a + 2
            # print(self.a)


class Player2(pygame.sprite.Sprite):
    def __init__(self):
        self.image = pygame.image.load("img_2.png").convert_alpha()
        self.image = pygame.transform.scale(self.image, (50, 100))
        self.rect = self.image.get_rect()
        self.rect.left = (w - self.image.get_width()) // 2
        self.rect.top = h - self.image.get_height()
        self.rect.midbottom = (600, h - 10)
        self.speed = 5
        self.allSprites = pygame.sprite.Group()
        self.shoot_deley = 100
        self.last = 0

    def draw_plane(self,scr):
        scr.blit(self.image, self.rect)


    def moveleft(self):
        if self.rect.left >= 0:
            self.rect.left -= self.speed

    def moveright(self):
        if self.rect.right <= w:
            self.rect.right += self.speed

    def moveup(self):
        if self.rect.top >= 0:
            self.rect.top -= self.speed

    def movedown(self):
        if self.rect.bottom <= h:
            self.rect.top += self.speed




    def update(self, *args):
        self.rect.centery += self.speedy



class Player1(pygame.sprite.Sprite):
    def __init__(self):
        self.image = pygame.image.load("img_1.png").convert_alpha()
        self.image = pygame.transform.scale(self.image, (50, 100))
        self.rect = self.image.get_rect()
        self.rect.left = (w - self.image.get_width()) // 2
        self.rect.top = h - self.image.get_height()
        self.rect.midbottom = (200, h - 10)
        self.speed = 5
        self.allSprites = pygame.sprite.Group()
        self.shoot_deley = 100
        self.last = 0

    def draw_plane(self,scr):
        scr.blit(self.image, self.rect)


    def moveleft(self):
        if self.rect.left >= 0:
            self.rect.left -= self.speed

    def moveright(self):
        if self.rect.right <= w:
            self.rect.right += self.speed

    def moveup(self):
        if self.rect.top >= 0:
            self.rect.top -= self.speed

    def movedown(self):
        if self.rect.bottom <= h:
            self.rect.top += self.speed




    def update(self, *args):
        self.rect.centery += self.speedy



class Rocks(pygame.sprite.Sprite):



    def __init__(self,a):
        pygame.sprite.Sprite.__init__(self)
        self.a = a
        self.b = self.a * 2

        img = pygame.image.load("img.png").convert_alpha()
        self.image= pygame.transform.scale(img, (50, 50))
        self.rect = self.image.get_rect()
        self.rect.top = random.randint(1, 5)
        self.rect.left = random.randint(1, w)
        self.speed_x = random.randint(-3, 3)
        self.speed_y = random.randint(self.a,self.b)
        # print(self.a)






    def update(self, *args):
        if self.rect.x<=0 or self.rect.x==w or self.rect.y >= h:
            self.kill()



        self.rect.x += self.speed_x
        self.rect.y += self.speed_y


if __name__ == '__main__':
    war = MainWindow()
    war.gostart()
    war.show()



